package
{
	import org.flixel.*;
	public class HelpState extends FlxState
	{
		public var option1:FlxText;
		public var option2:FlxText;
		public var selected:int;
		
		public var restrictions:Array = [
"To protect the safety of your users' accounts, the following restrictions apply to all passcodes (press up/down to scroll):\n\n\
Must not start with 0.\n\
Must be exactly 6 characters long.\n\
Must not contain the same digit twice.\n\
Must not have any non-trivial factors.\n\
No two neighbouring digits may be consecutive (have difference +/-1).\n\
Neighbouring digits must not share factors.\n\
No two even or odd digits should be side by side.\n\
There should be no triples of digits in ascent or descent ( 138, 852, &c ).\n\n\n\
Press RETURN to go back"
			];
		public var title:FlxText;

		override public function create():void
		{
			selected=0;
			bgColor = 0xFF000000;
			title= new FlxText(1,1,FlxG.width-1,restrictions[0]);
			title.size=8;
			title.alignment="left";		
			title.color=0xffFFFFFF;
			add(title);
			position=0;
		}
		
		public var position:int;
		
		override public function update():void
		{
			if (FlxG.keys.justPressed("DOWN"))
			{
				position=Math.max(position-1,-16);
				title.y=1+10*position;				
			}
			if (FlxG.keys.justPressed("UP"))
			{
				position=Math.min(position+1,0);
				title.y=1+10*position;				
			}
			
			if (FlxG.keys.justPressed("SPACE")||FlxG.keys.justPressed("X")|| FlxG.keys.justPressed("ENTER"))
			{				
				FlxG.state = new NewAccountScreen();
			}
			super.update();
		}
	}
}