package
{
	import org.osmf.layout.AbsoluteLayoutFacet;

	public class NumberChecker
	{

		private static function getDigit(n:int,d:int):int
		{
			return (n/(Math.pow(10,d)))%10;
		}
		
		private static function noRepeatingDigits(n:int):Boolean
		{
			for (var i:int=0;i<6;i++)
			{
				for (var j:int=i+1;j<6;j++)
				{
					if (getDigit(n,i)==getDigit(n,j))
						return false
				}
			}
			return true;
		}		

		private static function noConsecutiveDigits(n:int):Boolean
		{
			for (var d:int=1;d<6;d++)
			{
				var dist:int = getDigit(n,d-1)-getDigit(n,d);
				if (dist==1 || dist==-1)
					return false;
			}
			return true;
		}
				
		
		private static function relativelyPrime(a:int,b:int):Boolean
		{
			var x:int=Math.min(a,b);
			var y:int=Math.max(a,b);
			for (var i:int=2;i<x+1;i++)
			{
				if (x%i==0 && y%i==0)
					return false;
			}
			return true;
		}
		
		private static function neighbouringRelativePrime(n:int):Boolean
		{
			for (var d:int=1;d<6;d++)
			{
				if (!relativelyPrime(getDigit(n,d-1),getDigit(n,d)))
					return false;
			}
			return true;
		}		

		private static function noStringsAscendingOrDescending(n:int):Boolean
		{
			for (var d:int=2;d<6;d++)
			{
				var d1:int = getDigit(n,d-2)-getDigit(n,d-1);
				var d2:int = getDigit(n,d-1)-getDigit(n,d);
				if ((d1>0)==(d2>0))
					return false;
			}
			return true;
		}
		

		private static function evenoddalternate(n:int):Boolean
		{
			var lastDigit:Boolean;
			for (var d:int=0;d<6;d++)
			{
				var parity:Boolean = getDigit(n,d)%2==0;
				if (d>0)
				{
					if (parity==lastDigit)
						return false;					
				}
				lastDigit=parity;
			}
			return true;
		}
		
		private static function isPrime(n:int):Boolean
		{
			for (var x:int=2;x<=Math.sqrt(n);x++)
			{
				if (n%x==0)
					return false;
			}
			return true;
		}
			
		public static function IsValid(n:String):Boolean
		{
			if (n.length!=6)
				return false;
			
			var i:int = int(n);
			
			if (isPrime(i) &&
				noRepeatingDigits(i) &&
				noConsecutiveDigits(i) &&
				neighbouringRelativePrime(i) &&
				noStringsAscendingOrDescending(i) &&
				evenoddalternate(i)								
			)
			{
				return true;
			}
			
			return false;
		}
	}
}